/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "tm_p.h"
#include "hashtab.h"
#include "hash-set.h"
#include "vec.h"
#include "machmode.h"
#include "hard-reg-set.h"
#include "input.h"
#include "function.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "hard-reg-set.h"
#include "predict.h"
#include "basic-block.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "predict.h"



/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.

   The third argument to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it
   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.c) to fill in the CLOBBERs.


   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/


extern rtx gen_split_61 (rtx_insn *, rtx *);
extern rtx gen_split_69 (rtx_insn *, rtx *);
extern rtx gen_split_84 (rtx_insn *, rtx *);
extern rtx gen_split_85 (rtx_insn *, rtx *);
extern rtx gen_split_86 (rtx_insn *, rtx *);



static int
recog_1 (rtx x0 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x1 ATTRIBUTE_UNUSED;
  rtx x2 ATTRIBUTE_UNUSED;
  rtx x3 ATTRIBUTE_UNUSED;
  rtx x4 ATTRIBUTE_UNUSED;
  int tem ATTRIBUTE_UNUSED;

  x1 = XEXP (x0, 0);
  switch (GET_MODE (x1))
    {
    case SImode:
      goto L342;
    case DImode:
      goto L335;
    case HImode:
      goto L337;
    case QImode:
      goto L338;
    case SFmode:
      goto L339;
    case DFmode:
      goto L340;
    default:
      break;
    }
 L138: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x1) == PC)
    goto L241;
  if (register_operand (x1, VOIDmode))
    {
      operands[0] = x1;
      goto L255;
    }
 L300: ATTRIBUTE_UNUSED_LABEL
  operands[0] = x1;
  goto L301;

 L342: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x1) == REG)
    goto L345;
 L334: ATTRIBUTE_UNUSED_LABEL
  if (register_operand (x1, SImode))
    {
      operands[0] = x1;
      goto L2;
    }
 L336: ATTRIBUTE_UNUSED_LABEL
  if (nonimmed_operand (x1, SImode))
    {
      operands[0] = x1;
      goto L94;
    }
  goto L138;

 L345: ATTRIBUTE_UNUSED_LABEL
  switch (XINT (x1, 0))
    {
    case 1LL:
      goto L261;
    case 0LL:
      goto L277;
    case 7LL:
      goto L295;
    default:
      break;
    }
  goto L334;

 L261: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SImode
      && GET_CODE (x1) == UNSPEC_VOLATILE
      && XVECLEN (x1, 0) == 1
      && XINT (x1, 1) == 2)
    goto L262;
  x1 = XEXP (x0, 0);
  goto L334;

 L262: ATTRIBUTE_UNUSED_LABEL
  x2 = XVECEXP (x1, 0, 0);
  if (const_int_operand (x2, SImode))
    {
      operands[0] = x2;
      return 44;  /* entry */
    }
  x1 = XEXP (x0, 0);
  goto L334;

 L277: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SImode
      && GET_CODE (x1) == UNSPEC_VOLATILE
      && XVECLEN (x1, 0) == 1
      && XINT (x1, 1) == 6)
    goto L278;
  x1 = XEXP (x0, 0);
  goto L334;

 L278: ATTRIBUTE_UNUSED_LABEL
  x2 = XVECEXP (x1, 0, 0);
  if (register_operand (x2, SImode))
    {
      operands[0] = x2;
      goto L279;
    }
  x1 = XEXP (x0, 0);
  goto L334;

 L279: ATTRIBUTE_UNUSED_LABEL
  if (pnum_clobbers != NULL)
    {
      *pnum_clobbers = 1;
      return 47;  /* eh_set_a0_windowed */
    }
  x1 = XEXP (x0, 0);
  goto L334;

 L295: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SImode
      && GET_CODE (x1) == UNSPEC_VOLATILE
      && XVECLEN (x1, 0) == 1
      && XINT (x1, 1) == 1)
    goto L296;
  x1 = XEXP (x0, 0);
  goto L334;

 L296: ATTRIBUTE_UNUSED_LABEL
  x2 = XVECEXP (x1, 0, 0);
  if (x2 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    {
      return 51;  /* set_frame_ptr */
    }
  x1 = XEXP (x0, 0);
  goto L334;

 L2: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SImode)
    goto L348;
  x1 = XEXP (x0, 0);
  goto L336;

 L348: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x1))
    {
    case PLUS:
      goto L3;
    case MINUS:
      goto L15;
    case MULT:
      goto L27;
    case ABS:
      goto L46;
    case CLZ:
      goto L50;
    case NEG:
      goto L54;
    case AND:
      goto L58;
    case IOR:
      goto L63;
    case XOR:
      goto L68;
    case ZERO_EXTEND:
      goto L73;
    case SIGN_EXTEND:
      goto L81;
    case ZERO_EXTRACT:
      goto L85;
    case ASHIFT:
      goto L115;
    case ASHIFTRT:
      goto L120;
    case LSHIFTRT:
      goto L125;
    case ROTATE:
      goto L130;
    case ROTATERT:
      goto L135;
    case IF_THEN_ELSE:
      goto L222;
    default:
     break;
   }
  x1 = XEXP (x0, 0);
  goto L336;

 L3: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode)
    goto L367;
  x1 = XEXP (x0, 0);
  goto L336;

 L367: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x2) == MULT)
    goto L9;
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L4;
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L9: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      operands[1] = x3;
      goto L10;
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L10: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (addsubx_operand (x3, SImode))
    {
      operands[3] = x3;
      goto L11;
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L11: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 2;  /* *addx */
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L4: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (add_operand (x2, SImode))
    {
      operands[2] = x2;
      return 1;  /* addsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L15: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode)
    goto L369;
  x1 = XEXP (x0, 0);
  goto L336;

 L369: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x2) == MULT)
    goto L21;
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L16;
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L21: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      operands[1] = x3;
      goto L22;
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L22: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (addsubx_operand (x3, SImode))
    {
      operands[3] = x3;
      goto L23;
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L23: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 4;  /* *subx */
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L16: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 3;  /* subsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L27: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode)
    goto L371;
  x1 = XEXP (x0, 0);
  goto L336;

 L371: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x2))
    {
    case SIGN_EXTEND:
      goto L33;
    case ZERO_EXTEND:
      goto L40;
    case REG:
    case SUBREG:
      goto L370;
    default:
      x1 = XEXP (x0, 0);
      goto L336;
   }
 L370: ATTRIBUTE_UNUSED_LABEL
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L28;
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L33: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (register_operand (x3, HImode))
    {
      operands[1] = x3;
      goto L34;
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L34: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == SIGN_EXTEND)
    goto L35;
  x1 = XEXP (x0, 0);
  goto L336;

 L35: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (register_operand (x3, HImode))
    {
      operands[2] = x3;
      return 6;  /* mulhisi3 */
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L40: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (register_operand (x3, HImode))
    {
      operands[1] = x3;
      goto L41;
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L41: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == ZERO_EXTEND)
    goto L42;
  x1 = XEXP (x0, 0);
  goto L336;

 L42: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (register_operand (x3, HImode))
    {
      operands[2] = x3;
      return 7;  /* umulhisi3 */
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L28: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 5;  /* mulsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L46: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      return 8;  /* abssi2 */
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L50: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      return 9;  /* clzsi2 */
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L54: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      return 10;  /* negsi2 */
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L58: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L59;
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L59: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (mask_operand (x2, SImode))
    {
      operands[2] = x2;
      return 11;  /* andsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L63: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L64;
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L64: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 12;  /* iorsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L68: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L69;
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L69: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      return 13;  /* xorsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L73: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case HImode:
      goto L373;
    case QImode:
      goto L374;
    default:
      break;
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L373: ATTRIBUTE_UNUSED_LABEL
  if (nonimmed_operand (x2, HImode))
    {
      operands[1] = x2;
      return 14;  /* zero_extendhisi2 */
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L374: ATTRIBUTE_UNUSED_LABEL
  if (nonimmed_operand (x2, QImode))
    {
      operands[1] = x2;
      return 15;  /* zero_extendqisi2 */
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L81: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (sext_operand (x2, HImode))
    {
      operands[1] = x2;
      return 16;  /* extendhisi2_internal */
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L85: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L86;
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L86: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (extui_fldsz_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L87;
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L87: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (const_int_operand (x2, SImode))
    {
      operands[3] = x2;
      return 17;  /* extzv_internal */
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L115: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L116;
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L116: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (arith_operand (x2, SImode))
    {
      operands[2] = x2;
      return 24;  /* ashlsi3_internal */
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L120: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L121;
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L121: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (arith_operand (x2, SImode))
    {
      operands[2] = x2;
      return 25;  /* ashrsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L125: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L126;
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L126: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (arith_operand (x2, SImode))
    {
      operands[2] = x2;
      return 26;  /* lshrsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L130: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L131;
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L131: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (arith_operand (x2, SImode))
    {
      operands[2] = x2;
      return 27;  /* rotlsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L135: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L136;
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L136: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (arith_operand (x2, SImode))
    {
      operands[2] = x2;
      return 28;  /* rotrsi3 */
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L222: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (branch_operator (x2, VOIDmode))
    {
      operands[4] = x2;
      goto L223;
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L223: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      operands[1] = x3;
      goto L224;
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L224: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L225;
  x1 = XEXP (x0, 0);
  goto L336;

 L225: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[2] = x2;
      goto L226;
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L226: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (register_operand (x2, SImode))
    {
      operands[3] = x2;
      return 37;  /* movsicc_internal0 */
    }
  x1 = XEXP (x0, 0);
  goto L336;

 L94: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (move_operand (x1, SImode))
    {
      operands[1] = x1;
      goto L95;
    }
  x1 = XEXP (x0, 0);
  goto L138;

 L95: ATTRIBUTE_UNUSED_LABEL
  if (
#line 766 "../../gcc/gcc/config/xtensa/xtensa.md"
(xtensa_valid_move (SImode, operands)))
    {
      return 19;  /* movsi_internal */
    }
  x1 = XEXP (x0, 0);
  goto L138;

 L335: ATTRIBUTE_UNUSED_LABEL
  if (nonimmed_operand (x1, DImode))
    {
      operands[0] = x1;
      goto L90;
    }
  goto L138;

 L90: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (move_operand (x1, DImode))
    {
      operands[1] = x1;
      goto L91;
    }
  x1 = XEXP (x0, 0);
  goto L138;

 L91: ATTRIBUTE_UNUSED_LABEL
  if (
#line 736 "../../gcc/gcc/config/xtensa/xtensa.md"
(register_operand (operands[0], DImode)
   || register_operand (operands[1], DImode)))
    {
      return 18;  /* movdi_internal */
    }
  x1 = XEXP (x0, 0);
  goto L138;

 L337: ATTRIBUTE_UNUSED_LABEL
  if (nonimmed_operand (x1, HImode))
    {
      operands[0] = x1;
      goto L98;
    }
  goto L138;

 L98: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (move_operand (x1, HImode))
    {
      operands[1] = x1;
      goto L99;
    }
  x1 = XEXP (x0, 0);
  goto L138;

 L99: ATTRIBUTE_UNUSED_LABEL
  if (
#line 801 "../../gcc/gcc/config/xtensa/xtensa.md"
(xtensa_valid_move (HImode, operands)))
    {
      return 20;  /* movhi_internal */
    }
  x1 = XEXP (x0, 0);
  goto L138;

 L338: ATTRIBUTE_UNUSED_LABEL
  if (nonimmed_operand (x1, QImode))
    {
      operands[0] = x1;
      goto L102;
    }
  goto L138;

 L102: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (move_operand (x1, QImode))
    {
      operands[1] = x1;
      goto L103;
    }
  x1 = XEXP (x0, 0);
  goto L138;

 L103: ATTRIBUTE_UNUSED_LABEL
  if (
#line 829 "../../gcc/gcc/config/xtensa/xtensa.md"
(xtensa_valid_move (QImode, operands)))
    {
      return 21;  /* movqi_internal */
    }
  x1 = XEXP (x0, 0);
  goto L138;

 L339: ATTRIBUTE_UNUSED_LABEL
  if (nonimmed_operand (x1, SFmode))
    {
      operands[0] = x1;
      goto L106;
    }
 L341: ATTRIBUTE_UNUSED_LABEL
  if (register_operand (x1, SFmode))
    {
      operands[0] = x1;
      goto L229;
    }
  goto L138;

 L106: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (move_operand (x1, SFmode))
    {
      operands[1] = x1;
      goto L107;
    }
  x1 = XEXP (x0, 0);
  goto L341;

 L107: ATTRIBUTE_UNUSED_LABEL
  if (
#line 901 "../../gcc/gcc/config/xtensa/xtensa.md"
(((register_operand (operands[0], SFmode)
     || register_operand (operands[1], SFmode))
    && !(FP_REG_P (xt_true_regnum (operands[0]))
         && (constantpool_mem_p (operands[1]) || CONSTANT_P (operands[1]))))))
    {
      return 22;  /* movsf_internal */
    }
  x1 = XEXP (x0, 0);
  goto L341;

 L229: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SFmode
      && GET_CODE (x1) == IF_THEN_ELSE)
    goto L230;
  x1 = XEXP (x0, 0);
  goto L138;

 L230: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (branch_operator (x2, VOIDmode))
    {
      operands[4] = x2;
      goto L231;
    }
  x1 = XEXP (x0, 0);
  goto L138;

 L231: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      operands[1] = x3;
      goto L232;
    }
  x1 = XEXP (x0, 0);
  goto L138;

 L232: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L233;
  x1 = XEXP (x0, 0);
  goto L138;

 L233: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SFmode))
    {
      operands[2] = x2;
      goto L234;
    }
  x1 = XEXP (x0, 0);
  goto L138;

 L234: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (register_operand (x2, SFmode))
    {
      operands[3] = x2;
      return 38;  /* movsfcc_internal0 */
    }
  x1 = XEXP (x0, 0);
  goto L138;

 L340: ATTRIBUTE_UNUSED_LABEL
  if (nonimmed_operand (x1, DFmode))
    {
      operands[0] = x1;
      goto L110;
    }
  goto L138;

 L110: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (move_operand (x1, DFmode))
    {
      operands[1] = x1;
      goto L111;
    }
  x1 = XEXP (x0, 0);
  goto L138;

 L111: ATTRIBUTE_UNUSED_LABEL
  if (
#line 1007 "../../gcc/gcc/config/xtensa/xtensa.md"
(register_operand (operands[0], DFmode)
   || register_operand (operands[1], DFmode)))
    {
      return 23;  /* movdf_internal */
    }
  x1 = XEXP (x0, 0);
  goto L138;

 L241: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (register_operand (x1, SImode))
    {
      operands[0] = x1;
      return 40;  /* indirect_jump_internal */
    }
  switch (GET_CODE (x1))
    {
    case IF_THEN_ELSE:
      goto L140;
    case LABEL_REF:
      goto L238;
    default:
     break;
   }
  x1 = XEXP (x0, 0);
  goto L300;

 L140: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (branch_operator (x2, VOIDmode))
    {
      operands[3] = x2;
      goto L141;
    }
  if (ubranch_operator (x2, VOIDmode))
    {
      operands[3] = x2;
      goto L159;
    }
 L176: ATTRIBUTE_UNUSED_LABEL
  if (boolean_operator (x2, VOIDmode))
    {
      operands[3] = x2;
      goto L177;
    }
  x1 = XEXP (x0, 0);
  goto L300;

 L141: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      operands[0] = x3;
      goto L142;
    }
  goto L176;

 L142: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (branch_operand (x3, SImode))
    {
      operands[1] = x3;
      goto L143;
    }
  goto L176;

 L143: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L144;
    case PC:
      goto L153;
    default:
     break;
   }
  x2 = XEXP (x1, 0);
  goto L176;

 L144: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  goto L145;

 L145: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 29;  /* *btrue */
    }
  x2 = XEXP (x1, 0);
  goto L176;

 L153: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF)
    goto L154;
  x2 = XEXP (x1, 0);
  goto L176;

 L154: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  return 30;  /* *bfalse */

 L159: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      operands[0] = x3;
      goto L160;
    }
  x1 = XEXP (x0, 0);
  goto L300;

 L160: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (ubranch_operand (x3, SImode))
    {
      operands[1] = x3;
      goto L161;
    }
  x1 = XEXP (x0, 0);
  goto L300;

 L161: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L162;
    case PC:
      goto L171;
    default:
     break;
   }
  x1 = XEXP (x0, 0);
  goto L300;

 L162: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  goto L163;

 L163: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 31;  /* *ubtrue */
    }
  x1 = XEXP (x0, 0);
  goto L300;

 L171: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF)
    goto L172;
  x1 = XEXP (x0, 0);
  goto L300;

 L172: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  return 32;  /* *ubfalse */

 L177: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode)
    goto L375;
  x1 = XEXP (x0, 0);
  goto L300;

 L375: ATTRIBUTE_UNUSED_LABEL
  switch (GET_CODE (x3))
    {
    case ZERO_EXTRACT:
      goto L178;
    case AND:
      goto L202;
    default:
     break;
   }
  x1 = XEXP (x0, 0);
  goto L300;

 L178: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      operands[0] = x4;
      goto L179;
    }
  x1 = XEXP (x0, 0);
  goto L300;

 L179: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 1);
  if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + (1)])
    goto L180;
  x1 = XEXP (x0, 0);
  goto L300;

 L180: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 2);
  if (arith_operand (x4, SImode))
    {
      operands[1] = x4;
      goto L181;
    }
  x1 = XEXP (x0, 0);
  goto L300;

 L181: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L182;
  x1 = XEXP (x0, 0);
  goto L300;

 L182: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L183;
    case PC:
      goto L195;
    default:
     break;
   }
  x1 = XEXP (x0, 0);
  goto L300;

 L183: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  goto L184;

 L184: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 33;  /* *bittrue */
    }
  x1 = XEXP (x0, 0);
  goto L300;

 L195: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF)
    goto L196;
  x1 = XEXP (x0, 0);
  goto L300;

 L196: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  return 34;  /* *bitfalse */

 L202: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      operands[0] = x4;
      goto L203;
    }
  x1 = XEXP (x0, 0);
  goto L300;

 L203: ATTRIBUTE_UNUSED_LABEL
  x4 = XEXP (x3, 1);
  if (register_operand (x4, SImode))
    {
      operands[1] = x4;
      goto L204;
    }
  x1 = XEXP (x0, 0);
  goto L300;

 L204: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 1);
  if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    goto L205;
  x1 = XEXP (x0, 0);
  goto L300;

 L205: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L206;
    case PC:
      goto L217;
    default:
     break;
   }
  x1 = XEXP (x0, 0);
  goto L300;

 L206: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  goto L207;

 L207: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC)
    {
      return 35;  /* *masktrue */
    }
  x1 = XEXP (x0, 0);
  goto L300;

 L217: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF)
    goto L218;
  x1 = XEXP (x0, 0);
  goto L300;

 L218: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  return 36;  /* *maskfalse */

 L238: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  return 39;  /* jump */

 L255: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_CODE (x1) == CALL)
    goto L256;
  x1 = XEXP (x0, 0);
  goto L300;

 L256: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == MEM)
    goto L257;
  x1 = XEXP (x0, 0);
  goto L300;

 L257: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  if (call_insn_operand (x3, SImode))
    {
      operands[1] = x3;
      goto L258;
    }
  x1 = XEXP (x0, 0);
  goto L300;

 L258: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  return 43;  /* call_value_internal */

 L301: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == BLKmode
      && GET_CODE (x1) == UNSPEC
      && XVECLEN (x1, 0) == 1
      && XINT (x1, 1) == 11)
    goto L302;
  goto ret0;

 L302: ATTRIBUTE_UNUSED_LABEL
  x2 = XVECEXP (x1, 0, 0);
  if (rtx_equal_p (x2, operands[0]))
    {
      return 53;  /* *memory_barrier */
    }
  goto ret0;
 ret0:
  return -1;
}

int
recog (rtx x0 ATTRIBUTE_UNUSED,
	rtx uncast_insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x1 ATTRIBUTE_UNUSED;
  rtx x2 ATTRIBUTE_UNUSED;
  rtx x3 ATTRIBUTE_UNUSED;
  rtx x4 ATTRIBUTE_UNUSED;
  int tem ATTRIBUTE_UNUSED;
  recog_data.insn = NULL_RTX;
  rtx_insn *insn ATTRIBUTE_UNUSED;
  insn = safe_as_a <rtx_insn *> (uncast_insn);

  switch (GET_CODE (x0))
    {
    case SET:
      goto L1;
    case PARALLEL:
      goto L329;
    case CALL:
      goto L250;
    case CONST_INT:
      goto L330;
    case UNSPEC_VOLATILE:
      goto L331;
    case TRAP_IF:
      goto L291;
    case UNSPEC:
      goto L333;
    default:
     break;
   }
  goto ret0;

 L1: ATTRIBUTE_UNUSED_LABEL
  return recog_1 (x0, insn, pnum_clobbers);

 L329: ATTRIBUTE_UNUSED_LABEL
  if (XVECLEN (x0, 0) == 2)
    goto L243;
  goto ret0;

 L243: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 0);
  switch (GET_CODE (x1))
    {
    case SET:
      goto L270;
    case RETURN:
      goto L265;
    case UNSPEC_VOLATILE:
      goto L377;
    default:
     break;
   }
  goto ret0;

 L270: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == REG
      && XINT (x2, 0) == 0)
    goto L271;
  if (GET_CODE (x2) == PC)
    goto L245;
  goto ret0;

 L271: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == UNSPEC_VOLATILE
      && XVECLEN (x2, 0) == 1
      && XINT (x2, 1) == 6)
    goto L272;
  goto ret0;

 L272: ATTRIBUTE_UNUSED_LABEL
  x3 = XVECEXP (x2, 0, 0);
  if (register_operand (x3, SImode))
    {
      operands[0] = x3;
      goto L273;
    }
  goto ret0;

 L273: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L274;
  goto ret0;

 L274: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[1] = x2;
      return 47;  /* eh_set_a0_windowed */
    }
  goto ret0;

 L245: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      operands[0] = x2;
      goto L246;
    }
  goto ret0;

 L246: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == USE)
    goto L247;
  goto ret0;

 L247: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == LABEL_REF)
    goto L248;
  goto ret0;

 L248: ATTRIBUTE_UNUSED_LABEL
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  return 41;  /* tablejump_internal */

 L265: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == USE)
    goto L266;
  goto ret0;

 L266: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == REG
      && XINT (x2, 0) == 0
      && 
#line 1663 "../../gcc/gcc/config/xtensa/xtensa.md"
((TARGET_WINDOWED_ABI || !xtensa_current_frame_size) && reload_completed))
    {
      return 45;  /* return */
    }
  goto ret0;

 L377: ATTRIBUTE_UNUSED_LABEL
  if (XVECLEN (x1, 0) == 1
      && XINT (x1, 1) == 6)
    goto L282;
  goto ret0;

 L282: ATTRIBUTE_UNUSED_LABEL
  x2 = XVECEXP (x1, 0, 0);
  if (register_operand (x2, SImode))
    {
      operands[0] = x2;
      goto L283;
    }
  goto ret0;

 L283: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L284;
  goto ret0;

 L284: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[1] = x2;
      return 48;  /* eh_set_a0_call0 */
    }
  goto ret0;

 L250: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 0);
  if (GET_CODE (x1) == MEM)
    goto L251;
  goto ret0;

 L251: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (call_insn_operand (x2, SImode))
    {
      operands[0] = x2;
      goto L252;
    }
  goto ret0;

 L252: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  operands[1] = x1;
  return 42;  /* call_internal */

 L330: ATTRIBUTE_UNUSED_LABEL
  if (XWINT (x0, 0) == 0LL)
    {
      return 46;  /* nop */
    }
  goto ret0;

 L331: ATTRIBUTE_UNUSED_LABEL
  if (XVECLEN (x0, 0) == 1)
    goto L378;
  goto ret0;

 L378: ATTRIBUTE_UNUSED_LABEL
  switch (XINT (x0, 1))
    {
    case 6LL:
      goto L286;
    case 8LL:
      goto L289;
    default:
      break;
    }
  goto ret0;

 L286: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 0);
  if (register_operand (x1, SImode))
    {
      operands[0] = x1;
      goto L287;
    }
  goto ret0;

 L287: ATTRIBUTE_UNUSED_LABEL
  if (pnum_clobbers != NULL)
    {
      *pnum_clobbers = 1;
      return 48;  /* eh_set_a0_call0 */
    }
  goto ret0;

 L289: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 0);
  if (x1 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    {
      return 49;  /* blockage */
    }
  goto ret0;

 L291: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 0);
  if (x1 == const_int_rtx[MAX_SAVED_CONST_INT + (1)])
    goto L292;
  goto ret0;

 L292: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (x1 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    {
      return 50;  /* trap */
    }
  goto ret0;

 L333: ATTRIBUTE_UNUSED_LABEL
  if (XVECLEN (x0, 0) == 1
      && XINT (x0, 1) == 2)
    goto L298;
  goto ret0;

 L298: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 0);
  if (x1 == const_int_rtx[MAX_SAVED_CONST_INT + (0)])
    {
      return 52;  /* *unspec_nop */
    }
  goto ret0;
 ret0:
  return -1;
}

rtx
split_insns (rtx x0 ATTRIBUTE_UNUSED, rtx uncast_insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x1 ATTRIBUTE_UNUSED;
  rtx x2 ATTRIBUTE_UNUSED;
  rtx x3 ATTRIBUTE_UNUSED;
  rtx x4 ATTRIBUTE_UNUSED;
  rtx tem ATTRIBUTE_UNUSED;
  recog_data.insn = NULL_RTX;
  rtx_insn *insn ATTRIBUTE_UNUSED;
  insn = safe_as_a <rtx_insn *> (uncast_insn);

  switch (GET_CODE (x0))
    {
    case SET:
      goto L304;
    case PARALLEL:
      goto L380;
    default:
     break;
   }
  goto ret0;

 L304: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 0);
  switch (GET_MODE (x1))
    {
    case DImode:
      goto L381;
    case DFmode:
      goto L382;
    case SImode:
      goto L383;
    default:
      break;
    }
  goto ret0;

 L381: ATTRIBUTE_UNUSED_LABEL
  if (nonimmed_operand (x1, DImode))
    {
      operands[0] = x1;
      goto L305;
    }
  goto ret0;

 L305: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (move_operand (x1, DImode))
    {
      operands[1] = x1;
      goto L306;
    }
  goto ret0;

 L306: ATTRIBUTE_UNUSED_LABEL
  if (
#line 739 "../../gcc/gcc/config/xtensa/xtensa.md"
(reload_completed))
    {
      return gen_split_61 (insn, operands);
    }
  goto ret0;

 L382: ATTRIBUTE_UNUSED_LABEL
  if (nonimmed_operand (x1, DFmode))
    {
      operands[0] = x1;
      goto L309;
    }
  goto ret0;

 L309: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (move_operand (x1, DFmode))
    {
      operands[1] = x1;
      goto L310;
    }
  goto ret0;

 L310: ATTRIBUTE_UNUSED_LABEL
  if (
#line 1010 "../../gcc/gcc/config/xtensa/xtensa.md"
(reload_completed))
    {
      return gen_split_69 (insn, operands);
    }
  goto ret0;

 L383: ATTRIBUTE_UNUSED_LABEL
  if (GET_CODE (x1) == REG
      && XINT (x1, 0) == 7)
    goto L327;
  goto ret0;

 L327: ATTRIBUTE_UNUSED_LABEL
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SImode
      && GET_CODE (x1) == UNSPEC_VOLATILE
      && XVECLEN (x1, 0) == 1
      && XINT (x1, 1) == 1)
    goto L328;
  goto ret0;

 L328: ATTRIBUTE_UNUSED_LABEL
  x2 = XVECEXP (x1, 0, 0);
  if (x2 == const_int_rtx[MAX_SAVED_CONST_INT + (0)]
      && 
#line 1810 "../../gcc/gcc/config/xtensa/xtensa.md"
(reload_completed && !frame_pointer_needed))
    {
      return gen_split_86 (insn, operands);
    }
  goto ret0;

 L380: ATTRIBUTE_UNUSED_LABEL
  if (XVECLEN (x0, 0) == 2)
    goto L312;
  goto ret0;

 L312: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 0);
  switch (GET_CODE (x1))
    {
    case SET:
      goto L313;
    case UNSPEC_VOLATILE:
      goto L384;
    default:
     break;
   }
  goto ret0;

 L313: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == REG
      && XINT (x2, 0) == 0)
    goto L314;
  goto ret0;

 L314: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode
      && GET_CODE (x2) == UNSPEC_VOLATILE
      && XVECLEN (x2, 0) == 1
      && XINT (x2, 1) == 6)
    goto L315;
  goto ret0;

 L315: ATTRIBUTE_UNUSED_LABEL
  x3 = XVECEXP (x2, 0, 0);
  if (register_operand (x3, SImode))
    {
      operands[0] = x3;
      goto L316;
    }
  goto ret0;

 L316: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L317;
  goto ret0;

 L317: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L318;
    }
  goto ret0;

 L318: ATTRIBUTE_UNUSED_LABEL
  if (
#line 1738 "../../gcc/gcc/config/xtensa/xtensa.md"
(reload_completed))
    {
      return gen_split_84 (insn, operands);
    }
  goto ret0;

 L384: ATTRIBUTE_UNUSED_LABEL
  if (XVECLEN (x1, 0) == 1
      && XINT (x1, 1) == 6)
    goto L321;
  goto ret0;

 L321: ATTRIBUTE_UNUSED_LABEL
  x2 = XVECEXP (x1, 0, 0);
  if (register_operand (x2, SImode))
    {
      operands[0] = x2;
      goto L322;
    }
  goto ret0;

 L322: ATTRIBUTE_UNUSED_LABEL
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER)
    goto L323;
  goto ret0;

 L323: ATTRIBUTE_UNUSED_LABEL
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      operands[1] = x2;
      goto L324;
    }
  goto ret0;

 L324: ATTRIBUTE_UNUSED_LABEL
  if (
#line 1750 "../../gcc/gcc/config/xtensa/xtensa.md"
(reload_completed))
    {
      return gen_split_85 (insn, operands);
    }
  goto ret0;
 ret0:
  return 0;
}

